--                                                                    --
--  package                         Copyright (c)  Dmitry A. Kazakov  --
--     Fuzzy.Linguistics.Measures.                 Luebeck            --
--        Empirical_Defuzzification                Autumn, 2005       --
--  Interface                                                         --
--                                Last revision :  21:18 12 Sep 2005  --
--                                                                    --
--  This  library  is  free software; you can redistribute it and/or  --
--  modify it under the terms of the GNU General Public  License  as  --
--  published by the Free Software Foundation; either version  2  of  --
--  the License, or (at your option) any later version. This library  --
--  is distributed in the hope that it will be useful,  but  WITHOUT  --
--  ANY   WARRANTY;   without   even   the   implied   warranty   of  --
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  --
--  General  Public  License  for  more  details.  You  should  have  --
--  received  a  copy  of  the GNU General Public License along with  --
--  this library; if not, write to  the  Free  Software  Foundation,  --
--  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    --
--                                                                    --
--  As a special exception, if other files instantiate generics from  --
--  this unit, or you link this unit with other files to produce  an  --
--  executable, this unit does not by  itself  cause  the  resulting  --
--  executable to be covered by the GNU General Public License. This  --
--  exception  does not however invalidate any other reasons why the  --
--  executable file might be covered by the GNU Public License.       --
--____________________________________________________________________--
--
--  Empirical_Defuzzification -- An empirical defuzzification method
--
--     A - The variable to defuzzify
--
--  The generic parameter is the dimensionless  defuzzification  method.
--  It should be an instance of either: 
--
--     Fuzzy.Linguistics.Center_Of_Area,
--     Fuzzy.Linguistics.Center_Of_Gravity,
--     Fuzzy.Linguistics.Leftmost_Max,
--     Fuzzy.Linguistics.Rightmost_Max.
--
--  The result has the dimension and the offset of the parameter. 
--
--  Returns :
--
--     Defuzzified value
--
--  Exceptions :
--
--     Constraint_Error - The result is undefined
--
generic
   with function Method (A : Variable) return Number;
function Fuzzy.Linguistics.Measures.Empirical_Defuzzification
         (  A : Variable_Measure
         )  return Measure;
